#!/bin/sh
env="mujoco"
scenario="Ant-v2"
agent_conf="4x2"
agent_obsk=1
algo="mafocops"
exp="4-2"
seed=5

echo "env is ${env}, scenario is ${scenario}, algo is ${algo}, exp is ${exp}, max seed is ${seed_max}"
echo "seed is ${seed}:"
CUDA_VISIBLE_DEVICES=2 nohup python -u train/train_mujoco.py  --env_name ${env} --algorithm_name ${algo} --experiment_name ${exp} --scenario ${scenario} --agent_conf ${agent_conf} --agent_obsk ${agent_obsk} --lr 9e-5 --critic_lr 5e-3 --std_x_coef 1 --std_y_coef 5e-1 --seed ${seed} --n_training_threads 4 --n_rollout_threads 16 --num_mini_batch 40 --episode_length 1000 --num_env_steps 10000000 --ppo_epoch 1 --use_value_active_masks  --add_center_xy --use_state_agent  --kl_threshold 0.0125 --focops_eta 0.025 --safety_bound 50 --ls_step 5 --entropy_coef 0 --focops_lam 2.2 --nu_max 1.3 --nu_lr 0.00005 --batch_size 256 > test6.log &
